//+------------------------------------------------------------------+
//|                                                  Pivot_Crazy.mq4 |
//|                                                  Profi_R |
//|                                               Dm_35 2008 |
//|                                    http://www.fxexpert.ru/forum/ |
//+------------------------------------------------------------------+
#property copyright "Dm_35"
#property link      "dm34@mail.ru"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Yellow
#property indicator_color2 White
#property indicator_width1 2
#property indicator_width2 2
//---- input parameters
extern int       T_F=60;
extern int       limit=2000;
extern int       lm=0;
//---- buffers
double R1Buffer[];
double PBuffer[];


//----
int Displacement;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(7);
   SetIndexStyle(1,DRAW_SECTION);
   SetIndexBuffer(0,PBuffer);
   SetIndexBuffer(1,R1Buffer);   
   SetIndexLabel(0,"M60 Pivot");
   SetIndexLabel(1,"M60 trend");   
   if( lm==0)
         Displacement=T_F/Period();
      else
         Displacement=1;

   SetIndexShift(0,Displacement);
   SetIndexShift(1,Displacement);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int cb,sbb_index,sbb_Aux_i,sbe_Aux_i,i;
   int counted_bars=IndicatorCounted();
   datetime Corresp_bbbnTime;
   double StHigh,StLow,DHigh,DLow,SStaticStep,SDBStep;
 
   for(cb=limit;cb>=0;cb--)
   {
      Corresp_bbbnTime=NormTimeBarBegin(Time[cb],T_F);
      sbb_index=n_iBarShift(Corresp_bbbnTime,Period());
      
      StHigh=High[iHighest(NULL,0,MODE_HIGH,sbb_index-cb+1,cb)];
      StLow=Low[iLowest(NULL,0,MODE_LOW,sbb_index-cb+1,cb)];
      
      PBuffer[cb]=MathRound((Close[cb]+StHigh+StLow)/3/Point)*Point;
      R1Buffer[cb]=PBuffer[cb];

      if( cb<sbb_index )
      {
         for(i=cb+1;i<=sbb_index;i++)
         {
            PBuffer[i]=PBuffer[cb];
            R1Buffer[i]=EMPTY_VALUE;
            //R1Buffer[i]=(2*PBuffer[i])-StLow;
            //R2Buffer[i]=PBuffer[cb]+(StHigh - StLow);
            //R3Buffer[i]=(2*PBuffer[cb])+(StHigh-(2*StLow));
            //S1Buffer[i]=(2*PBuffer[i])-StHigh;
            //S2Buffer[i]=PBuffer[cb]-(StHigh - StLow);
            //S3Buffer[i]=(2*PBuffer[cb])-((2* StHigh)-StLow);
         }
      }

    
   }

//-----------------
   return(0);
  }
//-----------------
datetime NormTimeBarBegin(datetime intime, int TF)
  {
   datetime outtime;
   if(TF!=10080)
   {
      outtime=MathFloor(intime/TF/60)*TF*60;
   }
   else
   {
      outtime=MathFloor((intime+345600)/TF/60)*TF*60-345600;
   }
   return(outtime);
  }
//-----------------
int n_iBarShift(datetime intime, int TF)
  {
   int bindex,b_count;
   datetime TArray[];
   b_count=ArrayCopySeries(TArray,MODE_TIME,Symbol(),TF);
   bindex=ArrayBsearch(TArray,NormTimeBarBegin(intime,TF),0,0,MODE_ASCEND) ;
   return(bindex);
  }
//-----------------  

